"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPubkeyTreeMatchRuleV2Serializer = exports.pubkeyTreeMatchV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const pubkeyTreeMatchV2 = (pubkeyField, proofField, root) => ({
    type: 'PubkeyTreeMatch',
    pubkeyField,
    proofField,
    root: [...root],
});
exports.pubkeyTreeMatchV2 = pubkeyTreeMatchV2;
const getPubkeyTreeMatchRuleV2Serializer = (context) => {
    const s = context.serializer;
    return (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(context, ruleType_1.RuleTypeV2.PubkeyTreeMatch, s.struct([
        ['pubkeyField', s.string({ size: 32 })],
        ['proofField', s.string({ size: 32 })],
        [
            'root',
            (0, umi_1.mapSerializer)(s.bytes({ size: 32 }), (v) => new Uint8Array(v), (v) => [...v]),
        ],
    ]));
};
exports.getPubkeyTreeMatchRuleV2Serializer = getPubkeyTreeMatchRuleV2Serializer;
//# sourceMappingURL=pubkeyTreeMatch.js.map